#!/bin/bash
USER_AGENT=$1
CONF_EXTEN=$2
TIMEOUT=$3

if [[ -z "$USER_AGENT" ]]; then
    USER_AGENT="Wildix W-AIR-SP/HS,Wildix W-AIR-SBR2/HS"
fi

if [[ -z "$CONF_EXTEN" ]]; then
    CONF_EXTEN="*Wairhotline*"
fi

if [[ -z $3 || "$TIMEOUT" -le "0" ]]; then
    TIMEOUT=10
fi

HALF_TIMEOUT=$((TIMEOUT / 2))

SQL_COND=""

function prepare_sql_cond() {
    local IFS=,
    local WORD_LIST=($1)
    for word in "${WORD_LIST[@]}"; do
        SQL_COND+="user_agent like '$word%' or "
    done
}

prepare_sql_cond "$USER_AGENT"

SQL_COND=${SQL_COND::-4}

SQL="select username, contact from location WHERE username not like 'unknown%' and ($SQL_COND)"

function fix_calls_on_hold()
{
    HELD_LIST=$(callweaver -x'core show hints' | grep 'State:Hold' | cut -d'/' -f2 | cut -d' ' -f1)
    USERS=$1
    for LINE in ${HELD_LIST[@]}; do
        if [[ " ${USERS[*]} " =~ " ${LINE} " ]]; then
            COUNT=$(callweaver -x'core show channels' | grep "/$LINE-" | wc -l)
            if [[ "$COUNT" -eq 1 ]]; then
                CHAN=$(callweaver -x'core show channels' | grep "/$LINE-" | cut -d' ' -f1)
                callweaver -x"sip notify broadsoft $CHAN talk"
            fi
        fi
    done
}


while true; do
   REGS=$(sqlite3 /dev/shm/wmsdb.d/kamailio/usrloc.db "$SQL")
   sleep $HALF_TIMEOUT
   LIST=$(callweaver -x'core show channels' | grep SIP | cut -d '-' -f1 | cut -d '/' -f2)
   USERS=()
   for LINE in ${REGS[@]}; do
      ITEM=$(echo $LINE | cut -d '|' -f1)
      USERS+=($ITEM)
      if [[ ! $LIST =~ $ITEM ]]; then
         CONTACT=$(echo $LINE | cut -d '|' -f2)
         callweaver -x"sip request refer $ITEM $CONF_EXTEN $CONTACT"
         sleep 1
      fi
   done
   sleep $HALF_TIMEOUT

   fix_calls_on_hold $USERS

done